﻿using MongoDB.Driver;
using NetServer.MongoDB.DBData;

namespace NetServer.MongoDB;

public class DBDataLink<T>
{
    protected IMongoCollection<T> _playerMongoCollection;

    protected void Init(DBLink dbLink,string dbName)
    {
        _playerMongoCollection = dbLink.MongoDatabase.GetCollection<T>(dbName);
    }

    protected void Insert(T bsonDocument)
    {
        _playerMongoCollection.InsertOne(bsonDocument);
    }

    protected void Update(FilterDefinition<T> filter, UpdateDefinition<T> update)
    {
        _playerMongoCollection.UpdateManyAsync(filter, update);
    }

    protected async Task<T> FindOneDataAsync(FilterDefinition<T> filter)
    {
        return await _playerMongoCollection.Find(filter).FirstOrDefaultAsync();
    }
}