﻿using MongoDB.Driver;
using NetServer.MongoDB.DBData;

namespace NetServer.MongoDB;

public class PlayerDataLink : DBDataLink<PlayerData>
{
    public static PlayerDataLink PlayerDbLink
    {
        get
        {
            if (_playerDbLink == null)
            {
                _playerDbLink = new PlayerDataLink();
            }

            return _playerDbLink;
        }
    }

    private static PlayerDataLink _playerDbLink;

    public void InitPlayerData(DBLink dbLink)
    {
        base.Init(dbLink, "player");
    }

    public void InsertPlayerData(PlayerData playerData)
    {
        base.Insert(playerData);
    }

    public void UpdatePlayerData(PlayerData bsonDocument)
    {
        var filter = Builders<PlayerData>.Filter
            .Eq(restaurant => restaurant.id, bsonDocument.id);
        var update = bsonDocument.Update;
        bsonDocument.Update = bsonDocument.CapyUpdate();
        base.Update(filter, update);
    }

    private async Task<PlayerData> FindOneDataAsyncPlayerData(long id)
    {
        var filter = Builders<PlayerData>.Filter
            .Eq(r => r.playerId, id);
        return await base.FindOneDataAsync(filter);
    }
}