﻿using System.Collections.Concurrent;
using System.Net;
using System.Net.Sockets;
using NetCore;
using NetCore.ContentParse;
using NetCore.NetServerCoreBasic;
using NetCore.Protocol;

namespace NetServer.NetLink.TCP;

public class TCPServer<T, K> : IServer where T : IContentParse where K : IProtocol
{
    // private byte[] buffData = new byte[6553];
    private Socket socket;

    public ILogicalParsing LogicalParsing
    {
        get { return _logicalParsing; }
    }

    private ILogicalParsing _logicalParsing;

    //记录半包数据
    private bool isBufferData;
    private byte[] lastBuffData;
    private int lastCount;

    private short lastXueLieHao;
    //数据结束

    //尾包
    private byte[] weiBaoBuffData;

    private long index;

    private ConcurrentDictionary<long, TCPServerConnection<T, K>> allTcpServerConnections =
        new ConcurrentDictionary<long, TCPServerConnection<T, K>>();


    public void Start()
    {
    }


    public void Init(IContentParse iContentParse, IProtocol iProtocol)
    {
    }

    public void AddGetData(object data)
    {
    }

    // private Thread _udpClientThread;

    // private byte[] buffer = new byte[2048];


    // public Dictionary<long, IServerConnection> KcpServerConnections = new Map<long, IServerConnection>();
    // private List<CombatSynchronizeRequest> CombatSynchronizeRequests = new List<CombatSynchronizeRequest>();
    // private List<IServerConnection> awaitConnections = new List<IServerConnection>();
    // private IServerManager iServerManager;
    public TCPServer(int port, ILogicalParsing logicalParsing)
    {
        _logicalParsing = logicalParsing;
        socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        socket.Bind(new IPEndPoint(IPAddress.Any, port));
        socket.Listen();
        AcceptAsync();
    }

    private async Task AcceptAsync()
    {
        try
        {
            if (socket == null)
            {
                return;
            }

            Socket newSocket = await socket.AcceptAsync();
            int code = newSocket.RemoteEndPoint.GetHashCode();
            TCPServerConnection<T, K> tcpServerConnection = new TCPServerConnection<T, K>(this, newSocket);
            index++;
            bool isAdd = allTcpServerConnections.TryAdd(index, tcpServerConnection);
            if (!isAdd)
            {
                Console.Error.WriteLine("添加失败");
            }

            AcceptAsync();
        }
        catch (Exception e)
        {
            Console.WriteLine(e);
        }
    }

    public void RemoveConnection(TCPServerConnection<T, K> tcpServerConnection)
    {
        bool isOk = allTcpServerConnections.TryRemove(tcpServerConnection.index, out TCPServerConnection<T, K> value);
        if (!isOk)
        {
            Console.Error.WriteLine("移除失败");
        }
    }
}